#!/usr/bin/python
import math
import pdb
from OpenGL.GL import *
from OpenGL.GLU import *
from PyQt4 import QtGui
from PyQt4.QtOpenGL import *
from PyQt4.Qt import Qt
from PyQt4 import QtCore
from PyNGL import *
import sys
import random
import pdb

class GLWindow(QGLWidget):

	def __init__(self, parent):
		QGLWidget.__init__(self, parent)
		self.setMinimumSize(1024, 720)
		self.m_spinYFace = 0
		self.m_spinXFace = 0
		self.m_origX = 0
		self.m_origY = 0
		self.m_transformStack=TransformStack()
		self.CurrentCamera=0


	def mousePressEvent (self,  _event) :

		# this method is called when the mouse button is pressed in this case we
		# store the value where the maouse was clicked (x,y) and set the Rotate flag to true
		if(_event.button() == Qt.LeftButton) :
			self.m_origX = _event.x();
			self.m_origY = _event.y();
			self.m_rotate =True;



	def mouseMoveEvent ( self,_event ) :
		# note the method buttons() is the button state when event was called
		# this is different from button() which is used to check which button was
		# pressed when the mousePress/Release event is generated

		if(self.m_rotate and _event.buttons() == Qt.LeftButton) :
			self.m_spinYFace = ( self.m_spinYFace + (_event.x() - self.m_origX) ) % 360
			self.m_spinXFace = ( self.m_spinXFace + (_event.y() - self.m_origY) ) % 360
			self.m_origX = _event.x();
			self.m_origY = _event.y();
			# re-draw GL
			self.updateGL();

	def mouseReleaseEvent (self,  _event) :

		# this event is called when the mouse button is released
		# we then set Rotate to false
		if (_event.button() == Qt.LeftButton) :
			self.m_rotate=False


	def paintGL(self):
			'''
			Drawing routine
			'''
			trans=Transformation()
			# set the mouse rotation
			trans.setRotation(self.m_spinXFace,self.m_spinYFace,0)
			# set this in the TX stack
			self.m_transformStack.setGlobal(trans);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)

			# Rotation based on the mouse position for our global
			# transform
			self.shader=ShaderManager.instance()

			self.shader.setShaderParamFromMatrix("gl3xTest","ViewMatrix",self.m_cam.getModelView())
			self.shader.setShaderParamFromMatrix("gl3xTest","projectionMatrix",self.m_cam.getProjection())
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);

			prim=VBOPrimitives.instance();



			self.m_transformStack.pushTransform();
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("teapot");
			self.m_transformStack.popTransform();

			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(-3,0.0,0.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("sphere");
			self.m_transformStack.popTransform();


			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(3,0.0,0.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("cylinder");
			self.m_transformStack.popTransform();

			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(0.0,0.0,3.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("cube");
			self.m_transformStack.popTransform();

			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(-3.0,0.0,3.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("torus");
			self.m_transformStack.popTransform();

			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(3.0,0.5,3.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("icosahedron");
			self.m_transformStack.popTransform();

			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(0.0,0.0,-3.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("cone");
			self.m_transformStack.popTransform();


			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(-3.0,0.5,-3.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("tetrahedron");
			self.m_transformStack.popTransform();


			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(3.0,0.5,-3.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("octahedron");
			self.m_transformStack.popTransform();


			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(0.0,0.5,-6.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("football");
			self.m_transformStack.popTransform();

			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(-3.0,0.5,-6.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("disk");
			self.m_transformStack.popTransform();


			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(3.0,0.5,-6.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("dodecahedron");
			self.m_transformStack.popTransform();

			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(-5.0,-0.5,0.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("Helix");
			self.m_transformStack.popTransform();


			self.m_transformStack.pushTransform();
			self.m_transformStack.getCurrentTransform().setPosition(Vector(0.0,-0.5,0.0));
			self.m_transformStack.loadGlobalAndCurrentMatrixToShader("gl3xTest","ModelMatrix",ACTIVEMATRIX.NORMAL);
			prim.draw("plane");
			self.m_transformStack.popTransform();


			glFlush()


	def resizeGL(self, w, h):
			'''
			Resize the GL window
			'''
			glViewport(0, 0, w, h)
			self.m_cam.setShape(65,float(w/h),0.5,10,CAMERAPROJECTION.PERSPECTIVE)





	def initializeGL(self):
			'''
			Initialize GL
			'''
			# set viewing projection
			glClearColor(0.0, 0.0, 0.0, 1.0)
			glClearDepth(1.0)
			self.Light0 = Light(Vector(5,12,0,1),Colour(1,1,1),Colour(1,1,1),LIGHTMODES.LIGHTLOCAL)
			self.Light0.enable()

			From=Vector(4,4,4)
			To=Vector(0,0,0)
			Up=Vector(0,1,0)
			self.m_cam=Camera(From,To,Up,CAMERAPROJECTION.PERSPECTIVE)
			self.m_cam.setShape(65,1024.0/720.0,0.5,10,CAMERAPROJECTION.PERSPECTIVE);

			glEnable(GL_LIGHTING)
			glShadeModel(GL_SMOOTH)
			glEnable(GL_DEPTH_TEST)
			glEnable(GL_NORMALIZE)
			glEnable(GL_TEXTURE_2D);
			glClearColor(0.5,0.5,0.5,1.0)
			self.shader=ShaderManager.instance()
			# load a frag and vert shaders
			self.shader.loadShader("gl3xTest","Vertex.vs","Fragment.fs","",False)
			# set this as the active shader
			self.shader.useShader("gl3xTest");
			# now pass the modelView and projection values to the shader
			self.shader.setShaderParamFromMatrix("gl3xTest","ViewMatrix",self.m_cam.getModelView())
			self.shader.setShaderParamFromMatrix("gl3xTest","projectionMatrix",self.m_cam.getProjection())

			prim=VBOPrimitives.instance();

			prim.createVBOSphere("sphere",0.5,50);
			prim.createVBOCylinder("cylinder",0.5,1.4,50,50);
			prim.createVBOCone("cone",0.5,1.4,20,20);

			prim.createVBODisk("disk",0.5,120);
			prim.createVBOQuadPlane("plane",20,20,80,80,Vector(0,1,0));
			prim.createVBOTorus("torus",0.15,0.4,20,20,False);
			prim.loadBinaryVBO("Helix","Helix.tnv",GL_TRIANGLES);


			m=Material(STDMAT.GOLD)
			m.use()
			glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE)


# You don't need anything below this
class NGLOpenGLDemo(QtGui.QMainWindow):

	def __init__(self):
		QtGui.QMainWindow.__init__(self)
		self.widget = GLWindow(self)
		self.setCentralWidget(self.widget)


	def keyPressEvent(self ,_event) :
		INC=0.1

		if _event.key() == Qt.Key_Q	:
			sys.exit()
		elif _event.key() == Qt.Key_W :
			glPolygonMode(GL_FRONT_AND_BACK,GL_LINE)
		elif _event.key() == Qt.Key_S :
			glPolygonMode(GL_FRONT_AND_BACK,GL_FILL)
		elif _event.key() == Qt.Key_Up :
			self.widget.m_cam.move(0.0,-INC,0.0)
		elif _event.key() == Qt.Key_Down :
			self.widget.m_cam.move(0.0,INC,0.0)
		elif _event.key() == Qt.Key_Left :
			self.widget.m_cam.move(INC,0.0,0.0)
		elif _event.key() == Qt.Key_Right :
			self.widget.m_cam.move(-INC,0.0,0.0)

		elif _event.key() == Qt.Key_I :
			self.widget.m_cam.move(0.0,0.0,INC)
		elif _event.key() == Qt.Key_O :
			self.widget.m_cam.move(0.0,0.0,-INC)

		self.widget.updateGL()


if __name__ == '__main__':
	app = QtGui.QApplication(['Spiral Widget Demo'])
	window = NGLOpenGLDemo()
	window.setWindowTitle("PyNGL Demo")
	window.show()
	app.exec_()